include $(TOP)/config/before.mk

CXX = CC
CXXLINK = CC
AR = CC -xar -o
RANLIB = echo
CP = cp
MKDIRHIER = mkdir -p
BinPattern = %
LibPattern = lib%.a
UseLibPattern = -l%

INSTALL         = installbsd -c
INSTLIBFLAGS    = -m 0644
INSTEXEFLAGS    = -m 0755

%.o: %.c
	$(CC) -c $(CFLAGS) -o ./$@ $<

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

%.o: $(SRC_DIR)/%.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

# OmniORB
BUILD_NAME = omniORB_260_sol25

LIB_DIR = $(TOP)/lib/$(BUILD_NAME)
BIN_DIR = $(TOP)/bin/$(BUILD_NAME)

CORBA_IMPL_ROOT = /home/iris/mencnar/ec/omniORB_2.6.0
CORBA_INCLUDE_DIR = -I$(CORBA_IMPL_ROOT)/include \
 -I$(CORBA_IMPL_ROOT)/src/lib/omniORB2 -I../../../../../stl
IDL_COMPILER  = $(CORBA_IMPL_ROOT)/bin/sun4_sosV_5.5/omniidl2
CXXMAKEDEPEND = $(CORBA_IMPL_ROOT)/bin/sun4_sosV_5.5/omkdepend -D__cplusplus -D_MSC_VER
CORBA_LIBDIR = $(CORBA_IMPL_ROOT)/lib/sun4_sosV_5.5
CORBA_LIB = -g -mt -lomniORB2 -lomnithread -ltcpwrapGK -lsocket -lnsl
CORBA_CXX_FLAGS = -g -mt -DXSTD= -DIRMOD= -DOMNIORB
CORBA_CXX_DEFINES = -D__sunos__ -D__sparc__ -D__OSVERSION__=5 -DSVR4 -DUsePthread -D_REENTRANT -DPthreadDraftVersion=10 -DPthreadSupportThreadPriority
IDL_DEFINES= -DOMNIORB
STUB_HDR_SUBST = $(STUB_DIR)/%.hh
STUB_SRC_SUBST = $(STUB_DIR)/%SK.cc
STUB_OBJ_SUBST = $(STUB_DIR)/%SK.o
IDLFLAGS = -I$(TOP)/idl -h.hh -sSK.cc -a

IMPORT_LIBRARY_FLAGS = $(patsubst %,-L:%/$(LIBDIR),$(IMPORT_TREES))

define CXXExecutable
(set -x; \
 $(RM) $@; \
 x=""; \
 for i in $$libs ; do \
  x="$$x $(patsubst %,$(UseLibPattern),$$i)"; \
 done; \
 $(CXXLINK) -o $@ $(CXXLINKOPTIONS) -L$(CORBA_LIBDIR) -L$(LIB_DIR) $^ $(CORBA_LIB)  $$x; \
)
endef

define StaticLinkLibrary
(set -x; \
 $(RM) $@; \
 $(AR) $@ $^; \
 $(RANLIB) $@; \
)
endef

define InstallLibrary
(dir="$(LIB_DIR)"; \
 files="$^"; \
 for file in $$files; do \
   $(InstallFile); \
 done; \
)
endef

include $(TOP)/config/rest.mk
include $(SRC_DIR)/dir.mk
include $(TOP)/config/last.mk


