// $Source: /home/iris/mencnar/ec/CVS/src/cc/IRread.cc,v $
//
// $Id: IRread.cc,v 1.3 1999/05/04 19:05:30 mencnar Exp $
//
// $Log: IRread.cc,v $
// Revision 1.3  1999/05/04 19:05:30  mencnar
// Trace messages redirected to a trace object
//
// Revision 1.2  1999/02/24 12:03:50  mencnar
// minor bug fixes
//
//

#include <iostream.h>

#include "trace.hh"
#include "IRread.hh"

int check_interface( IRMOD InterfaceDef_ptr intfdef,
		     ECHelper::TypedInterface &ret) {
  //  intfdef->_non_existent();
  IRMOD InterfaceDef::FullInterfaceDescription_var intfdesc=
    intfdef->describe_interface();
  trace.start(100)  << "describe_interface" << '\n';

  // it is the first call (not a recursive one)
  CORBA::String_var intfid_a= intfdesc->id;
  const char *intfid_b= (const char *) intfid_a;

  CORBA::String_var intfid;
  if (!strncmp( intfid_b, "IDL:/", 5)) {
    intfid= CORBA::string_alloc( strlen(intfid_b));
    strcpy( intfid, "IDL:");
    strcat( intfid, intfid_b+5);
  }
  else intfid= CORBA::string_dup( intfid_b);

  if (!ret.base_ids.length()) 
    ret.id= CORBA::string_dup( intfid);

  trace.start(100) << "Inteface id " << (const char *) intfid << '\n';
  trace.start(100) << "Defined in " 
		   << (const char *) intfdesc->defined_in << '\n';
  trace.start(100) << "Name " << (const char *) intfdesc->name << '\n';

  ret.base_ids.length( ret.base_ids.length()+1);
  ret.base_ids[ ret.base_ids.length()-1]= CORBA::string_dup(intfdesc->id);
  IRMOD InterfaceDefSeq_var base_intfs=
    intfdef->base_interfaces();
  for (CORBA::ULong x=0; x<base_intfs->length(); x++)
    if (!check_interface( base_intfs[x], ret)) return 0;

  if (intfdesc->attributes.length()) {
    trace.start(100) << "No attributes allowed for typed event channels" << '\n';
    return 0;
  }

  CORBA::ULong opbase= ret.ops.length();
  ret.ops.length( opbase + intfdesc->operations.length());
  for (CORBA::ULong i=0; i<intfdesc->operations.length(); i++) {
    if (intfdesc->operations[i].exceptions.length()) {
      trace.start(100) << "No exceptions allowed for type event channels" << '\n';
      return 0;
    }
    CORBA::TypeCode_ptr rettc=
      intfdesc->operations[i].result;

    if (!CORBA::_tc_void->equal( rettc) &&
	!CORBA::_tc_null->equal( rettc)) {
      trace.start(100) << "Return type of the operation must be void" << '\n';
      trace.start(100) << (int) intfdesc->type->kind() << '\n';
      return 0;
    }
    ret.ops[opbase+i].twoway= (CORBA::Boolean) 
      ((intfdesc->operations[i].mode == IRMOD OP_NORMAL) ? 1 : 0);
    trace.start(100) << (ret.ops[opbase+i].twoway ? "" : "oneway ")
		     << "[kind: " << (int) rettc->kind() << "] "
		     << (const char *) intfdesc->operations[i].name << "(";
    ret.ops[opbase+i].name= CORBA::string_dup( intfdesc->operations[i].name);
    CORBA::ULong nof_params= intfdesc->operations[i].parameters.length();
    ret.ops[opbase+i].parameter_types.length( nof_params);
    for (CORBA::ULong j=0; 
	 j<nof_params;
	 j++) {
      if (intfdesc->operations[i].parameters[j].mode !=
	  IRMOD PARAM_IN) {
	trace.start(100) << "All parameters must use \"in\" mode" << '\n';
	return 0;
      }
      ret.ops[opbase+i].parameter_types[j]=
      	CORBA::TypeCode::_duplicate( intfdesc->operations[i].parameters[j].type);
      trace.start(100) << "[kind: " 
		       << (int) intfdesc->operations[i].parameters[j].type->kind() 
		       << "] "
		       << (const char *) intfdesc->operations[i].parameters[j].name;
      if (j+1==nof_params) trace.start(100) << ")" << '\n';
      else trace.start(100) << ", ";	   
    }
  }  
  return 1;
}




