// $Id: ORBX_DSI.cc,v 1.1 1999/02/24 13:01:52 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/ORBX_DSI.cc,v $
//
// $Log: ORBX_DSI.cc,v $
// Revision 1.1  1999/02/24 13:01:52  mencnar
// *** empty log message ***
//
//

#ifdef ORBIX

#include "echelp.hh"
#include "ec_dsi.hh"
#include <omnithread.h>
#include <stdio.h>
#include <iostream.h>
#include "bootstrap.hh"
#include "IRread.hh"

class ORBX_DSI  : public CORBA::DynamicImplementation,
		  public EC_DSI 
{
  ECHelper::TypedInterface ti;
  EC_Dispatcher &ecdisp;
  int is_pull;
  CORBA::String_var intfname;
  CORBA::Object_var obj;
  ContainedSeq_var ctds;
public:
  ORBX_DSI( ECHelper::TypedInterface &_ti,
	    int _is_pull,
	    EC_Dispatcher &_ecdisp);
  virtual ~ORBX_DSI() {}

  virtual void invoke ( CORBA::ServerRequest&, CORBA::Environment&, 
			CORBA::Environment& IT_env = CORBA::IT_chooseDefaultEnv());

  CORBA::Object_ptr ORBX_DSI::get_object();
};

ORBX_DSI::
ORBX_DSI( ECHelper::TypedInterface &_ti,
	  int _is_pull,
	  EC_Dispatcher &_ecdisp) :
  ti( _ti),
  ecdisp( _ecdisp),
  is_pull( _is_pull)
{
  static omni_mutex marker_guard;
  static long marker_counter= 0;

  const char *prefix= (is_pull ? "Pull" : "");
  //  intfname= 
  //    CORBA::string_alloc( strlen(ti.id)+strlen(prefix)+1);
  //  strcpy(intfname, prefix);
  //  strcat(intfname, ti.id);
  char buf[40];

  omni_mutex_lock oml(marker_guard);
  sprintf(buf,"ORBX_DSI_%ld", ++marker_counter);

  // cerr << "Interface " << (const char *) intfname << endl;
  obj= CORBA::Orbix.setImpl( "TestIntf", *this, buf);
  cerr << "DSI object created" << endl;

  IRMOD Repository_var rep;
  CosNaming::NamingContext_var rootns= Bootstrap::getNS();
  try {
    rep= IRMOD Repository::_narrow( rootns->resolve( Bootstrap::SRV_IR()));
  }
  catch (...) {
  }
  if (CORBA::is_nil(rep)) {
    cerr << "Could not find Interface Repository service" << endl;
    return;
  }
  IRMOD Contained_var cntd;
  const char *intf_id= "IDL:/TestIntf:1.0";
  try {
    cntd= rep->lookup("::TestIntf");
    if (CORBA::is_nil(cntd)) {
      cerr << "Not found" << endl;
      throw 1;
    }
  }
  catch (CORBA::SystemException &se) {
    cerr << "SystemException" << se << endl;
  }
  catch (CORBA::UserException &ue) {
    cerr << "UserException" << endl;
  }
  catch (...) {
    cerr << "Lookup for " << intf_id << " failed" << endl;
    return;
  }

  //  cout << (const char *) Bootstrap::orb_ptr->object_to_string(cntd) << endl;

  IRMOD InterfaceDef_ptr idef;
  try {
    idef= IRMOD InterfaceDef::_narrow(cntd);
    if (CORBA::is_nil(idef)) throw 1;
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    return;
  }
  catch (...) {
    cerr << intf_id << " is not an interface" << endl;
    return;
  }

  ctds= idef->contents( dk_Operation, 0);
  for (CORBA::ULong i=0; i<ctds->length(); i++) {
    OperationDef_var opdef= OperationDef::_narrow( ctds[i]);
    cerr << opdef->name() << endl;
  }
}
  
CORBA::Object_ptr ORBX_DSI::
get_object() {
  return CORBA::Object::_duplicate( obj);
}

void ORBX_DSI::
invoke ( CORBA::ServerRequest& sr, CORBA::Environment& ex_env, 
	 CORBA::Environment& IT_env) {


  const char *opname= sr.operation();
  cerr << "dispatch " << opname << endl;

  
  for (CORBA::ULong opi=0; opi<ti.ops.length(); opi++) {
    CORBA::Boolean is_try_pull= 0;

    if (is_pull) {
      if (strncmp(opname,"pull_",strlen("pull_"))) {
	opname+= strlen("pull_");
      }
      else if (strncmp(opname,"try_",strlen("try_"))) {
	opname+= strlen("try_");
	is_try_pull= 1;
      }
      else {
	//	sr.exception( );
	return;
      }
    }    
    
    cerr << (const char *) ti.ops[opi].name << endl;
    if (strcmp(opname,(const char *) ti.ops[opi].name) == 0) {
      if (is_pull) {
      }
      else {
  
	try {
	static char xbuf[100];
	sprintf(xbuf,"aaaaaaaaaaaaaaaaaaaa");
	ECHelper::SeqAny params;
	params.length( ti.ops[opi].parameter_types.length());
	OperationDef_var opdef= OperationDef::_narrow( ctds[opi]);
	cerr << "Operation " << opdef->name() << endl;
	//	params.length( ti.ops[opi].parameter_types.length());
	CORBA::NVList_var nvl;
	
	Bootstrap::orb_ptr->create_list( 1,
					 nvl);
	for (CORBA::ULong x=0; x<params.length(); x++) {
	  CORBA::Any *an= new CORBA::Any( ti.ops[opi].parameter_types[x],
					  0);
	  nvl->add_value( "s", *an, CORBA::ARG_IN);

	}
	cerr << "Calling params" << endl;
	
	//	CORBA::Any a;
	//	nvl->add_value( "x", a, CORBA::DSI_ARG_IN, IT_env);
	// retrieve parameters
	CORBA::Environment xenv;
	sr.params( nvl, xenv);
	cerr << "params" << endl;
	for (CORBA::ULong i=0; i<params.length(); i++) {
	  cerr << "Params " << i << endl;
	  CORBA::NamedValue_ptr nv= nvl->item(i);
	  CORBA::Any *xa= nv->value();
	  cerr << (void *) xa->value() << endl;
	  char *s;
	  (*xa) >>= s;
	  cerr << s << endl;
	  params[i]= *xa;
	}
	//	cerr << (void *) params[0].value() << endl;
	
	if (xenv.exception()) {
	  cerr << *(xenv.exception()) << endl;
	}
	if (IT_env.exception()) {
	  cerr << *(IT_env.exception()) << endl;
	}
	
	// call implementation method
	//	(void) ecdisp.ec_dispatch( obj, ti.ops[opi].twoway, opname, params);
	}
	catch (CORBA::Exception &ex) {
	  cerr << "Exception " << ex << endl;
	}
	catch (...) {
	  cerr << "Unknown exception " << endl;
	}
	
      }
    }
  }
       
  //  sr.exception();
}

class ORBIX_EC_DSI_Factory : public EC_DSI_Factory {
  EC_DSI * create_ec_dsi( ECHelper::TypedInterface &_ti,
			  int _is_pull,
			  EC_Dispatcher &_ecdisp) {
    return new ORBX_DSI( _ti, _is_pull, _ecdisp);
  }
};

EC_DSI_Factory *default_ec_dsi_factory= new ORBIX_EC_DSI_Factory();

#endif
