#ifndef __ADMIN_HH__
#define __ADMIN_HH__

// $Id: admin.hh,v 1.2 1999/05/04 19:19:06 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/admin.hh,v $
//
// $Log: admin.hh,v $
// Revision 1.2  1999/05/04 19:19:06  mencnar
// Added support for creating channels with desired QoS parameters.
// Fixes in ORBIX port.
//
// Revision 1.1  1999/02/24 13:01:53  mencnar
// *** empty log message ***
//
//

//
// The implementation of ECAdmin::Factory IDL interface
//

#include "ecadmin.hh"
#include "compatibility.hh"
#include "locks.hh"

#include "ec.hh"

#ifndef NO_MCAST
#include "mcast.hh"
#endif

#include <map>
#include "xstring.hh"
#include "master_forwarder.hh"

class ECFactory_i
  : public BOA_IMPL_BASE(ECAdmin,Factory),
    public MyECController
{
  GeneralLock guard;
#ifndef NO_MCAST
  McastSourceFactory *mcast_src_factory;
#endif

  typedef XSTD::map<xstring,EventChannel_i*,
                    XSTD::less<xstring> > MapEChannels;
  MapEChannels echannels;
  // event channels

  MapEChannels techannels;
  // typed event channels

  McastMaster_i *mcast_master;

 public:  
  ECFactory_i(
#ifndef NO_MCAST
	    McastSourceFactory *_mcast_src_factory,
	    CosNaming::NamingContext_ptr nsroot,
	    const char *context_name,
	    unsigned long slave_keep_alive
#endif
	      );

  xstring get_unique_name( const MapEChannels &ecs);

  virtual void channel_disposed( EventChannel_i *);

  ECAdmin::ChannelDescriptions *
    channels( ENV_DECL1(ev));

  ECAdmin::TypedChannelDescriptions *
    typed_channels( ENV_DECL1(ev));

  CosEventChannelAdmin::EventChannel_ptr 
    create_event_channel( const char *name,
			  CORBA::ULong max_queue_size,
			  ECAdmin::OverflowAction oa,
			  CORBA::ULong not_connected_timeout,
			  CORBA::ULong keep_alive_time
			  ENV_DECL(ev));
  
  CosEventChannelAdmin::EventChannel_ptr
    create_unique_event_channel( char * &name,
				 CORBA::ULong max_queue_size,
				 ECAdmin::OverflowAction oa,
				 CORBA::ULong not_connected_timeout,
				 CORBA::ULong keep_alive_time
				 ENV_DECL(ev));

  CosTypedEventChannelAdmin::TypedEventChannel_ptr
    create_typed_event_channel( IRMOD::InterfaceDef_ptr idef,
				const char *name,
				CORBA::ULong max_queue_size,
				ECAdmin::OverflowAction oa,
				CORBA::ULong not_connected_timeout,
				CORBA::ULong keep_alive_time
				ENV_DECL(ev));
  
  CosTypedEventChannelAdmin::TypedEventChannel_ptr
    create_unique_typed_event_channel( IRMOD::InterfaceDef_ptr idef,
				       char * &name,
				       CORBA::ULong max_queue_size,
				       ECAdmin::OverflowAction oa,
				       CORBA::ULong not_connected_timeout,
				       CORBA::ULong keep_alive_time
				       ENV_DECL(ev));
  
  CosEventChannelAdmin::EventChannel_ptr 
    find_event_channel( const char *name
			ENV_DECL(ev));
  
  CosTypedEventChannelAdmin::TypedEventChannel_ptr
    find_typed_event_channel( const char *name
			      ENV_DECL(ev));

  void shutdown_factory( ENV_DECL1(ev));
};

#endif // __ADMIN_HH__

// end of $File$
//
