// $Source: /home/iris/mencnar/ec/CVS/src/cc/pushcons.cc,v $
//
// $Id: pushcons.cc,v 1.3 1999/05/04 19:34:54 mencnar Exp $
//
// $Log: pushcons.cc,v $
// Revision 1.3  1999/05/04 19:34:54  mencnar
// Clock synchronization for performance measurements.
//
// Revision 1.2  1999/02/24 12:57:33  mencnar
// *** empty log message ***
//
//

#include <iostream.h>
#include <stdlib.h>

#include "mtime.hh"
#include "CosEventChannelAdmin.hh"
#include "CosTypedEventChannelAdmin.hh"
#include "TestIntf.hh"
#include <omnithread.h>
#include "bootstrap.hh"
#include "compatibility.hh"


void kill_worker(void*) {
  omni_thread::sleep(1);
  exit(0);
}

class PushConsumer_I : public BOA_IMPL_BASE(CosEventComm,PushConsumer) 
{
  void disconnect_push_consumer( ENV_DECL1(env)) {
    cerr << "PushConsumer disconnected, exitting..." << endl;
    (new omni_thread(kill_worker,NULL))->start();
  }
  
  void push( const CORBA::Any &v
	     ENV_DECL(env)) {
    cerr << "Data received " << currtime() << endl;
    /*
    cerr << "push: ";
    try {
      char *s= NULL;
#ifdef OMNIORB
      CORBA::Any::to_string ts(s,0);
      v >>= ts;
#elif defined(ORBIX)
      v >>= s;
#endif
      if (strlen(s)>80) cerr << "String (" << strlen(s) << ")\n";
      else cerr << s;
#ifdef OMNIORB
      if (s) CORBA::string_free(s);
#endif
    }
    catch (...) {
    } 
    */
    cerr << endl;
  }
};

class TestIntf_I
  : public BOA_IMPL_BASE1(TestIntf)
{
  
  void operBoolean( CORBA::Boolean b, 
		    CORBA::Double d
		    ENV_DECL(env)) {
    cerr << "TestIntf: called operBoolean("
	 << (b ? "true" : "false") << ','
	 << (double) d << ')' << endl;
  }

  void operDouble( CORBA::Double d, 
		   CORBA::Boolean b
		   ENV_DECL(env)) {
    cerr << "TestIntf: called operDouble("
	 << (double) d << ','
	 << (b ? "true" : "false") << ')' << endl;
  }

  void operString( const char *s
		   ENV_DECL(env)) {
    cerr << currtime() << " operString " 
	 << (unsigned long) strlen(s) << endl;
    //    cerr << "TestIntf: called operString(" << s << ')' << endl;
  }

  void operAny( const CORBA::Any &a
		ENV_DECL(env)) {
    cerr << "TestIntf: called operAny( [kind="
	 << (int) a.type()->kind() << "] )" << endl;
  }

  void operPerf( const PerfTests &a
		 ENV_DECL(env)) {
    cerr << "Data received " << currtime() << endl;
    cerr << "operPerf (length) " << a.length() << endl;
  }
};

class TypedPushConsumer_I 
  : public BOA_IMPL_BASE(CosTypedEventComm,TypedPushConsumer) 
{
  TestIntf_var tconsumer;
 public:
  TypedPushConsumer_I( TestIntf_ptr tcon) :
    tconsumer( TestIntf::_duplicate( tcon)) {}

  void disconnect_push_consumer( ENV_DECL1(env)) {
    cerr << "PushConsumer disconnected, exitting..." << endl;
    exit(0);
  }
  
  void push( const CORBA::Any &v
	     ENV_DECL(env)) {
    cerr << "push: ";
    try {
      char *s= NULL;
#ifdef OMNIORB
      CORBA::Any::to_string ts(s,0);
      v >>= ts;
#elif defined(ORBIX)
      v >>= s;
#endif
      cerr << s;
#ifdef OMNIORB
      if (s) CORBA::string_free(s);
#endif
    }
    catch (...) {
    }  
    cerr << endl;
  }

  CORBA::Object_ptr get_typed_consumer( ENV_DECL1(env)) {
    cerr << "get_typed_consumer called" << endl;
    return TestIntf::_duplicate( tconsumer);
  }
};


void usage( const char *prog_name) {
  cerr << prog_name << " event_channel_name_in_NameServer [typed]" << endl;
  exit(1);
}

int main(int argc, char **argv) {
  Bootstrap::init(argc,argv);
  if (argc!=2 && argc!=3) usage(argv[0]);

  CosNaming::NamingContext_var nsroot;
  try {
    nsroot= Bootstrap::getNS();
  }
  catch (CORBA::Exception &ex) {
    cerr << "Could not resolve Naming Service reference " << ex << endl;
  }

  //---- should be deleted in final version, added for performance testing
  
  ECMcast::Master_var master;
  try {
    CosNaming::Name n(2);
    n.length(2);
    n[0].id= (const char *) "a";
    n[0].kind= (const char *) "a";
    n[1].id= (const char *) "Master";
    n[1].kind= (const char *) "Master";
    master= ECMcast::Master::_narrow( nsroot->resolve(n));
  }
  catch (...) {
  }
  synch_time( 300, master);
  omni_thread::sleep(90);
  synch_time( 300, master);
  
  //-----

  if (argc==2) {
    CosEventChannelAdmin::EventChannel_var ec;
    
    try {
      ec= CosEventChannelAdmin::EventChannel::_narrow(
		nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    cerr << "Found EC" << endl;
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Event Channel" << endl;
      return 1;
    }
    CosEventChannelAdmin::ProxyPushSupplier_var ppushsupp;
    try {
      CosEventChannelAdmin::ConsumerAdmin_var ca=
	ec->for_consumers();
      cerr << "for_consumers" << endl;
      ppushsupp= ca->obtain_push_supplier();
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ppushsupp)) {
      cerr << "Could not obtain ProxyPushSupplier from EventChannel" << endl;
      return 1;
    }
    
    PushConsumer_I &pushconsi= *(new PushConsumer_I());
    CONNECT_IMPL(Bootstrap::boa_ptr,&pushconsi);
    try {
      ppushsupp->connect_push_consumer( &pushconsi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a push supplier" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;
    IMPL_IS_READY(Bootstrap::boa_ptr);
  }
  else {
    // a typed consumer

    CosTypedEventChannelAdmin::TypedEventChannel_var ec;
    
    try {
      ec= CosTypedEventChannelAdmin::TypedEventChannel::_narrow(
		nsroot->resolve( Bootstrap::create_name(argv[1])));
    }
    catch (...) {}
    
    if (CORBA::is_nil(ec)) {
      cerr << "Could not find Event Channel" << endl;
      return 1;
    }
    cerr << "Found EC" << endl;
    
    CosEventChannelAdmin::ProxyPushSupplier_var ppushsupp;
    try {
      CosTypedEventChannelAdmin::TypedConsumerAdmin_var ca=
	ec->for_consumers();
      cerr << "for_consumers" << endl;
      ppushsupp= ca->obtain_typed_push_supplier( "");
    }
    catch (CORBA::SystemException &se) {
      cerr << "SystemException" << se << endl;
    }
    catch (...) {}
    
    if (CORBA::is_nil(ppushsupp)) {
      cerr << "Could not obtain ProxyPushSupplier from EventChannel" << endl;
      return 1;
    }
    TestIntf_I tti;
    CONNECT_IMPL(Bootstrap::boa_ptr,&tti);
    TypedPushConsumer_I &pushconsi= *(new TypedPushConsumer_I(&tti));
    CONNECT_IMPL(Bootstrap::boa_ptr,&pushconsi);
    try {
      ppushsupp->connect_push_consumer( &pushconsi);
    }
    catch (CosEventChannelAdmin::AlreadyConnected &) {
      cerr << "Already connected" << endl;
      return 1;
    }
    catch (...) {
      cerr << "Unable to connect a push supplier" << endl;
      return 1;
    }
    cerr << "Connection established" << endl;
    IMPL_IS_READY(Bootstrap::boa_ptr);
  }
}



