// $Id: timestamp.cc,v 1.3 1999/05/04 19:38:54 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/timestamp.cc,v $
//
// $Log: timestamp.cc,v $
// Revision 1.3  1999/05/04 19:38:54  mencnar
// Fixes in WIN32 port.
//
// Revision 1.2  1999/02/24 13:00:54  mencnar
// *** empty log message ***
//
//

#include "timestamp.hh"

#ifdef __WIN32__
#include <sys/types.h>
#include <sys/timeb.h>
#else
#include <sys/time.h>
#endif

class SystemTSFactory : public TimeStampFactory {
public:
  virtual TimeStamp instantiate();
};

TimeStamp SystemTSFactory::instantiate() {
  TimeStamp ret;
#ifdef __WIN32__
   struct timeb timebuffer;
   ftime(&timebuffer);
   ret.sec= timebuffer.time;
   ret.nsec= timebuffer.millitm*1000000L;
#else  
  timeval tv;
  gettimeofday(&tv,NULL);
  ret.sec= tv.tv_sec;
  ret.nsec= tv.tv_usec*1000L;
#endif
  return ret;
}

TimeStampFactory *default_tsf= new SystemTSFactory();
