// $Id: IORlib.hh,v 1.1 1999/05/21 16:45:21 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/hh/IORlib.hh,v $
//
// $Log: IORlib.hh,v $
// Revision 1.1  1999/05/21 16:45:21  mencnar
// *** empty log message ***
//
//

#ifdef OMNIORB
#include <omniORB2/CORBA.h>
#define my_byte_order ((CORBA::Char) omni::myByteOrder)
#else
#include <CORBA.h>

#ifdef __x86__
#define my_byte_order ((CORBA::Char) 1)
#elif defined(__sparc__)
#define my_byte_order ((CORBA::Char) 0)
#endif

#endif


#define USWAP(s) ((((s) & 0xff) << 8) | (((s) >> 8) & 0xff))
#define LSWAP(l) ((((l) & 0xff000000) >> 24) | \
                  (((l) & 0x00ff0000) >> 8) | \
                  (((l) & 0x0000ff00) << 8) | \
                  (((l) & 0x000000ff) << 24))



inline CORBA::ULong myalign( CORBA::ULong ptr,
			     CORBA::ULong size) {
  CORBA::ULong x= size-1;
  return (ptr+x) & ~x;
}


struct IORProfile {
  CORBA::ULong profileid;
  CORBA::Octet *data;
  CORBA::ULong profile_length;
  
  // IIOP profile
  CORBA::Char major_version;
  CORBA::Char minor_version;
  CORBA::String_var host;
  CORBA::UShort port;
  CORBA::Octet *object_key;
  CORBA::ULong object_key_length;

  IORProfile() :
    data( NULL), object_key(NULL) {}

  ~IORProfile() {
    if (data) delete []data;
    if (object_key) delete []object_key;
  }
};

struct IORProfiles {
  CORBA::Char byte_order;
  CORBA::String_var type_id;
  IORProfile *profiles;
  CORBA::ULong profiles_length;
  
  IORProfiles() : 
    profiles(NULL), profiles_length(0) {}
  ~IORProfiles() {
    if (profiles) delete []profiles;
  }

  CORBA::Char get_char( CORBA::Octet *data, 
			CORBA::ULong &ptr,
			CORBA::ULong len) {
    
    if (ptr+1 > len) throw 1;
    return (CORBA::Char)data[ptr++];
  }
  CORBA::ULong get_ushort( CORBA::Octet *data, 
			   CORBA::ULong &ptr,
			   CORBA::ULong len) {
    ptr= myalign(ptr, 2);
    if (ptr+2 > len) throw 1;
    CORBA::UShort ret= *((CORBA::UShort*)&data[ptr]);
    ptr+=2;
    if (byte_order!=my_byte_order) ret= USWAP(ret);
    return ret;
  }
  CORBA::ULong get_ulong( CORBA::Octet *data, 
			  CORBA::ULong &ptr,
			  CORBA::ULong len) {
    ptr= myalign(ptr, 4);
    if (ptr+4 > len) throw 1;
    CORBA::ULong ret= *((CORBA::ULong*)&data[ptr]);
    ptr+=4;
    if (byte_order!=my_byte_order) ret= LSWAP(ret);
    return ret;
  }
};

int IOR2Profiles( const char *str, IORProfiles &iorp);
