// $Id: mcast_interface.hh,v 1.1.1.1 1998/12/13 23:27:16 mencda Exp $
//
// $Source: /home/mencda/CVSROOT/ec/src/hh/mcast_interface.hh,v $
//
// $Log: mcast_interface.hh,v $
// Revision 1.1.1.1  1998/12/13 23:27:16  mencda
// Imported sources
//
//

#ifndef __MCAST_INTERFACE_HH__
#define __MCAST_INTERFACE_HH__

#include "ec_log.hh"
#include <unistd.h>

class McastSource;
class McastSink;

class McastInterfaceFactory {
  static McastInterfaceFactory *singleton;
public:
  McastInterfaceFactory *instance() {
    if (singleton) return singleton;
    eclog << "McastInterfaceFactory singleton not initialized "
	  << __FILE__ << ':' << __LINE__ << '\n';
    exit(1);
  }

  virtual McastSource *getMcastSource()= 0;
  virtual McastSink *getMcastSink()= 0;
};

class McastSource {
public:
  virtual void beginMessage()= 0;
  virtual void endMessage()= 0;
  virtual void sendData( void *data, unsigned len)= 0;

  virtual ~McastSource() {}
};

class McastSink {
public:
  virtual unsigned receiveData( void *data, unsigned len)= 0;

  virtual ~McastSink() {}
};


#endif  // __MCAST_INTERFACE_HH__

//
