package pl.edu.agh.ics.mev;

import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import CosEventChannelAdmin.*;
import CosTypedEventChannelAdmin.*;
import CosEventComm.*;
import CosTypedEventComm.*;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.TCKind;
import TestIntf;
import TestIntfHelper;
import _TestIntfImplBase;

public class PushConsFrame extends JFrame {

  //Construct the frame
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JPanel jPanel1 = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel1 = new JLabel();
  ObjectRef ORChannel= new ObjectRef(ObjectRef.PASTE);
  JButton BConnect = new JButton();

  org.omg.CORBA.ORB orb;
  ProxyPushSupplier ppsupp= null;
  ProxyPushSupplier tppsupp= null;
  TestIntf testintf= null;

  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JButton BDisconnect = new JButton();
  JPanel jPanel2 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  JTextArea TALog = new JTextArea();
  JButton BClear = new JButton();

  class PushConsumerImpl extends _PushConsumerImplBase {
    public PushConsumerImpl() {}

    public void push( Any v) {
      System.err.println("push");
      outer_push( v);
    }
    public void disconnect_push_consumer() {
      System.err.println("disconnect");
      disconnected();
    }
  };

  class TypedPushConsumerImpl extends _TypedPushConsumerImplBase {
    TestIntf ti;

    public TypedPushConsumerImpl() {
      orb.connect( ti= new TestIntfImpl());
    }

    public void push( Any v) {
      outer_push( v);
    }

    public void disconnect_push_consumer() {
      disconnected();
    }

    public org.omg.CORBA.Object get_typed_consumer() {
      return ti;
    }
  };

  class TestIntfImpl extends _TestIntfImplBase {
    public void operBoolean( boolean b, double d) {
      TALog.insert( "operBoolean("+b+", "+d+")\n", TALog.getCaretPosition());
    }

    public void operDouble( double d, boolean b) {
      TALog.insert( "operDouble("+d+", "+b+")\n", TALog.getCaretPosition());
    }

    public void operString( String s) {
      TALog.insert( "operString("+s+")\n", TALog.getCaretPosition());
    }

    public void operAny( Any v) {
      TALog.insert( "operAny(...)\n", TALog.getCaretPosition());
    }
  };

  public PushConsFrame( org.omg.CORBA.ORB orb) {
    this.orb= orb;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
//Component initialization

  private void jbInit() throws Exception  {
    this.getContentPane().setLayout(gridBagLayout2);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Sample Push Consumer");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    jLabel1.setText("Channel object");
    BConnect.setText("Connect");
    BConnect.setActionCommand("BConnect");
    BDisconnect.setEnabled(false);
    BDisconnect.setText("jButton2");
    BDisconnect.setLabel("Disconnect");
    TALog.setText("jTextArea1");
    BClear.setText("Clear");
    BClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BClear_actionPerformed(e);
      }
    });
    jPanel2.setLayout(gridBagLayout3);
    BDisconnect.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BDisconnect_actionPerformed(e);
      }
    });
    BConnect.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BConnect_actionPerformed(e);
      }
    });
    jPanel1.setLayout(gridBagLayout1);
    menuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    this.getContentPane().add(jPanel1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel1, new GridBagConstraints2(0, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(ORChannel, new GridBagConstraints2(1, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(BConnect, new GridBagConstraints2(2, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(BDisconnect, new GridBagConstraints2(3, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel2, new GridBagConstraints2(0, 1, 1, 1, 1.0, 50.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel2.add(jScrollPane1, new GridBagConstraints2(0, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jScrollPane1.getViewport().add(TALog, null);
    jPanel2.add(BClear, new GridBagConstraints2(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHWEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
  }
//File | Exit action performed

  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
//Help | About action performed

  public void helpAbout_actionPerformed(ActionEvent e) {
    PushConsFrame_AboutBox dlg = new PushConsFrame_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }
//Overriden so we can exit on System Close

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void BConnect_actionPerformed(ActionEvent e) {
    EventChannel ec=null;
    TypedEventChannel tec=null;
    org.omg.CORBA.Object obj= orb.string_to_object(ORChannel.getIOR());
    try {
      ec= EventChannelHelper.narrow(obj);
    }
    catch (Exception ex) {
    }
    try {
      if (ec==null) {
        tec= TypedEventChannelHelper.narrow(obj);
        if (tec==null) throw new Exception("Could not get EventChannel reference");
      }
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog(this,"Error getting event channel reference "+ex,
        "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    ppsupp= null;
    tppsupp= null;

    if (ec!=null) {
      try {
        ppsupp= ec.for_consumers().obtain_push_supplier();
        PushConsumer pushcons= new PushConsumerImpl();
        orb.connect( pushcons);
        ppsupp.connect_push_consumer( pushcons);
      }
      catch (Exception ex) {
        ex.printStackTrace();
        JOptionPane.showMessageDialog(this,"Error connecting to the event channel "+ex,
          "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      BConnect.setEnabled(false);
      BDisconnect.setEnabled(true);
    }
    else if (tec!=null) {
      try {
        tppsupp= tec.for_consumers().obtain_typed_push_supplier("::TestIntf");
        TypedPushConsumer pushcons= new TypedPushConsumerImpl();
        orb.connect( pushcons);
        tppsupp.connect_push_consumer( pushcons);
      }
      catch (Exception ex) {
        ex.printStackTrace();
        JOptionPane.showMessageDialog(this,"Error connecting to the event channel "+ex,
          "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      BConnect.setEnabled(false);
      BDisconnect.setEnabled(true);
    }
  }

  public void disconnected() {
    BConnect.setEnabled(true);
    BDisconnect.setEnabled(false);
  }

  void BDisconnect_actionPerformed(ActionEvent e) {
    try {
      if (ppsupp != null) ppsupp.disconnect_push_supplier();
      else if (tppsupp != null) tppsupp.disconnect_push_supplier();
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog(this,"Error disconnecting a proxy "+ex,
        "Error", JOptionPane.ERROR_MESSAGE);
      BConnect.setEnabled(true);
      return;
    }
    disconnected();
  }

  void BClear_actionPerformed(ActionEvent e) {
    TALog.setText("");
  }

  void outer_push( Any v) {
    int pos= TALog.getCaretPosition();
    switch (v.type().kind().value()) {
      case TCKind._tk_string:
        TALog.insert("push <string> "+v.extract_string(),pos);
        break;
      case TCKind._tk_short:
        TALog.insert("push <short> "+v.extract_short(),pos);
        break;
      case TCKind._tk_long:
        TALog.insert("push <long> "+v.extract_long(),pos);
        break;
      case TCKind._tk_double:
        TALog.insert("push <double> "+v.extract_double(),pos);
        break;
      default:
        TALog.insert("push", pos);
        break;
    }
    TALog.insert("\n",TALog.getCaretPosition());
  }
}


