INTERFACES = orb Naming CosEventComm CosEventChannelAdmin \
 CosTypedEventComm CosTypedEventChannelAdmin echelp ifr ecadmin ecmcast

CXXSRCS = mtp.cc mtpsink.cc mtpsource.cc mtpwebd.cc \
	mcast_srv.cc mcast_cli.cc

CXXINCLUDES = -I$(SRC_DIR)/../hh -I$(SRC_DIR)/../cc 

mtpd = $(patsubst %,$(BinPattern),mtpd)
mcast_cli = $(patsubst %,$(BinPattern),mcast_cli)
mcast_srv = $(patsubst %,$(BinPattern),mcast_srv)

lib = $(patsubst %,$(LibPattern),mtp)

all::	$(mcast_srv) $(mcast_cli) $(lib)

clean::
	$(RM) -rf $(mtpd) $(mcast_cli) $(mcast_srv) $(lib) *.o Templates.DB

$(mcast_cli):	$(STUB_OBJS) mtp.o mtpsink.o mtpsource.o mtpwebd.o mcast_cli.o
	@(libs="bootstrap";  $(CXXExecutable))

$(mcast_srv):	$(STUB_OBJS) mtp.o mtpsink.o mtpsource.o mtpwebd.o mcast_srv.o 
	@(libs="bootstrap";  $(CXXExecutable))

$(mtpd):	$(STUB_OBJS) mtp.o mtpsink.o mtpsource.o mtpwebd.o
	@(libs="bootstrap";  $(CXXExecutable))

$(lib):	$(STUB_OBJS) mtp.o mtpsink.o mtpsource.o mtpwebd.o glue.o
	@$(StaticLinkLibrary)

install:: $(lib)
	@$(InstallLibrary)

-include $(CXXSRCS:.cc=.d)


